package com.madeu.service.web.webuserpushhistory.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.madeu.constants.Constants;
import com.madeu.dao.web.webauthmenurelation.WebAuthMenuRelationSqlMapDAO;
import com.madeu.dao.web.webmember.WebMemberSqlMapDAO;
import com.madeu.dao.web.webuserpushhistory.WebUserPushHistorySqlMapDAO;
import com.madeu.service.web.webuserpushhistory.WebUserPushHistoryService;
import com.madeu.util.ValidationCheckUtil;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service("WebUserPushHistoryService")
public class WebUserPushHistoryServiceImpl implements WebUserPushHistoryService {

	@Autowired
	private WebMemberSqlMapDAO webMemberSqlMapDAO;
	
	@Autowired
	private WebUserPushHistorySqlMapDAO webUserPushHistorySqlMapDAO;
	
	@Autowired
	private WebAuthMenuRelationSqlMapDAO webAuthMenuRelationSqlMapDAO;
	
	/**
	 * 고객 - 알림 리스트 조회 화면으로 이동.
	 *
	 *
	 * @param paramMap
	 * @return
	 * @throws Exception
	 */
	@Override
	public HashMap<String, Object> selectListUserPushHistoryIntro(
			HashMap<String, Object> paramMap) throws Exception {
		log.debug("WebUserPushHistoryServiceImpl selectListUserPushHistoryIntro START");

		HashMap<String, Object> map = new HashMap<String, Object>();

		log.debug("loginMemberId       :"+paramMap.get("loginMemberId"));
		
		log.debug("menuClass           :"+paramMap.get("menuClass"));
		
		try{
			boolean check  = true;
			
			String menuClass    = String.valueOf(paramMap.get("menuClass"));
			
			// 정렬
			if(true != ValidationCheckUtil.emptyCheck(menuClass)){
				check = false;
				map.put("msgCode", Constants.FAIL);
				map.put("msgDesc","메뉴 정보가 없습니다.");
			}
			
			if(true == check){
				// 사용자 확인
				List<Map<String, Object>> userListMap = webMemberSqlMapDAO.checkMember(paramMap);
				int userListMapSize = userListMap.size();
				
				if(1==userListMapSize){
					paramMap.put("menuClassAuthId", userListMap.get(0).get("muAuthId"));
				}
				else {
					check = false;
					map.put("msgCode", Constants.FAIL);
					map.put("msgDesc", "사용자 정보가 올바르지 않습니다.");
				}
			}
			
			if(true == check){
				// 권한 조회
				HashMap<String, Object> authCheckParamMap = new HashMap<String, Object>();
				authCheckParamMap.put("menuClass",paramMap.get("menuClass"));
				authCheckParamMap.put("muAuthId",paramMap.get("menuClassAuthId"));
				List<Map<String, Object>> authMenuRelationlistMap = webAuthMenuRelationSqlMapDAO.selectAuthMenuRelation(authCheckParamMap);
				int authMenuRelationlistMapSize = authMenuRelationlistMap.size();
				
				if(1==authMenuRelationlistMapSize){
					map.put("msgCode", Constants.OK);
					map.put("success","true");
					
					map.put("selectUseYn", authMenuRelationlistMap.get(0).get("selectUseYn"));
					map.put("insertUseYn", authMenuRelationlistMap.get(0).get("insertUseYn"));
					map.put("updateUseYn", authMenuRelationlistMap.get(0).get("updateUseYn"));
					map.put("deleteUseYn", authMenuRelationlistMap.get(0).get("deleteUseYn"));
					map.put("downloadUseYn", authMenuRelationlistMap.get(0).get("downloadUseYn"));
				}
				else {
					map.put("msgCode", Constants.FAIL);
					map.put("msgDesc", "권한 정보가 없습니다.");
				}
			}
		}
		catch(Exception e){
			e.printStackTrace();
			throw e;
		}
		log.debug("WebUserPushHistoryServiceImpl selectListUserPushHistoryIntro END");
		return map;
	}
	
	/**
	 * 고객 - 알림 리스트 조회
	 *
	 *
	 * @param paramMap
	 * @return
	 * @throws Exception
	 */
	@Override
	public HashMap<String, Object> selectListUserPushHistory(
			HashMap<String, Object> paramMap) throws Exception {
		log.debug("WebUserPushHistoryServiceImpl selectListUserPushHistory START");

		HashMap<String, Object> map = new HashMap<String, Object>();

		log.debug("loginMemberId       :"+paramMap.get("loginMemberId"));
		
		log.debug("menuClass           :"+paramMap.get("menuClass"));
		
		log.debug("searchKeywordParam  :"+paramMap.get("searchKeywordParam"));
		log.debug("sort                :"+paramMap.get("sort"));
		log.debug("dir                 :"+paramMap.get("dir"));
		log.debug("start               :"+paramMap.get("start"));
		log.debug("limit               :"+paramMap.get("limit"));

		log.debug("searchStartDate     :"+paramMap.get("searchStartDate"));
		log.debug("searchEndDate       :"+paramMap.get("searchEndDate"));
		log.debug("searchType          :"+paramMap.get("searchType"));
		
		List<Map<String, Object>> listMap = new ArrayList<Map<String,Object>>();
		
		try{
			boolean check  = true;
			
			if(true == check){
				// 사용자 확인
				List<Map<String, Object>> userListMap = webMemberSqlMapDAO.checkMember(paramMap);
				int userListMapSize = userListMap.size();
				
				if(1==userListMapSize){
					paramMap.put("menuClassAuthId", userListMap.get(0).get("muAuthId"));
				}
				else {
					check = false;
					map.put("msgCode", Constants.FAIL);
					map.put("msgDesc", "사용자 정보가 올바르지 않습니다.");
				}
			}
			
			if(true == check){
				// 정렬 
				if(null==paramMap.get("dir")||("").equals(paramMap.get("dir"))){
					
				}
				else{
					String dir = String.valueOf(paramMap.get("dir"));
					if(("A").equals(dir)){
						paramMap.put("dir", "DESC");
					}
					else if(("B").equals(dir)){
						paramMap.put("dir", "ASC");
					}
					else {
						paramMap.put("dir", "DESC");
					}
				}
				
				paramMap.put("useYn", "Y");
				
				// 총 갯수 조회
				List<Map<String, Object>> totalCountListMap = webUserPushHistorySqlMapDAO.selectTotalUserPushHistoryCount(paramMap);
				int totalCount = Integer.parseInt(String.valueOf(totalCountListMap.get(0).get("totalCount")));
				
				if(0 < totalCount) {
					// 리스트 조회
					listMap = webUserPushHistorySqlMapDAO.selectListUserPushHistory(paramMap);
				}
				
				map.put("msgCode", Constants.OK);
				map.put("success","true");
				map.put("totalCount", totalCount);
				map.put("rows",listMap);
			}
		}
		catch(Exception e){
			e.printStackTrace();
			throw e;
		}
		log.debug("WebUserPushHistoryServiceImpl selectListUserPushHistory END");
		return map;
	}
	
	/**
	 * 고객 - 알림 리스트 조회 (List, Excel)
	 *
	 * @param paramMap
	 * @return
	 * @throws Exception
	 */
	@Override
	public List<Map<String, Object>> selectListUserPushHistoryExcel(
			HashMap<String, Object> paramMap) throws Exception {
		log.debug("WebUserPushHistoryServiceImpl selectListUserPushHistoryExcel START");

		HashMap<String, Object> map = new HashMap<String, Object>();

		log.debug("loginMemberId       :"+paramMap.get("loginMemberId"));
		
		log.debug("menuClass           :"+paramMap.get("menuClass"));

		log.debug("searchKeywordParam  :"+paramMap.get("searchKeywordParam"));
		log.debug("sort                :"+paramMap.get("sort"));
		log.debug("dir                 :"+paramMap.get("dir"));
		log.debug("start               :"+paramMap.get("start"));
		log.debug("limit               :"+paramMap.get("limit"));

		log.debug("searchStartDate     :"+paramMap.get("searchStartDate"));
		log.debug("searchEndDate       :"+paramMap.get("searchEndDate"));
		log.debug("searchType          :"+paramMap.get("searchType"));
		
		List<Map<String, Object>> listMap = new ArrayList<Map<String,Object>>();
		
		try{
			boolean check  = true;
			
			if(true == check){
				// 사용자 확인
				List<Map<String, Object>> userListMap = webMemberSqlMapDAO.checkMember(paramMap);
				int userListMapSize = userListMap.size();
				
				if(1==userListMapSize){
					paramMap.put("menuClassAuthId", userListMap.get(0).get("muAuthId"));
				}
				else {
					check = false;
					map.put("msgCode", Constants.FAIL);
					map.put("msgDesc", "사용자 정보가 올바르지 않습니다.");
				}
			}
			
			if(true == check){
				// 정렬 
				if(null==paramMap.get("dir")||("").equals(paramMap.get("dir"))){
					
				}
				else{
					String dir = String.valueOf(paramMap.get("dir"));
					if(("A").equals(dir)){
						paramMap.put("dir", "DESC");
					}
					else if(("B").equals(dir)){
						paramMap.put("dir", "ASC");
					}
					else {
						paramMap.put("dir", "DESC");
					}
				}
				
				paramMap.put("useYn", "Y");
				
				listMap = webUserPushHistorySqlMapDAO.selectListUserPushHistoryExcel(paramMap);
			}
		}
		catch(Exception e){
			e.printStackTrace();
			throw e;
		}
		log.debug("WebUserPushHistoryServiceImpl selectListUserPushHistoryExcel END");
		return listMap;
	}
}
